"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defer = void 0;
function defer() {
    var isPending = true;
    var resolve;
    var reject;
    var promise = new Promise(function (rs, rj) {
        resolve = function (result) {
            isPending = false;
            rs(result);
        };
        reject = function (error) {
            isPending = false;
            rj(error);
        };
    });
    return {
        resolve: resolve,
        reject: reject,
        promise: promise,
        isPending: function () {
            return isPending;
        }
    };
}
exports.defer = defer;
//# sourceMappingURL=Defer.js.map